%ext ck3

########################################################
#PATCHES FOR 'KEEN BONUS EPISODE: FATHERSHIP'S REVENGE'#
########################################################

################################################
#GENERATE 'BWB-TYPE' LEVEL THAT IS THE 16TH ONE#
################################################

#Only level 16 doesn't get marked as done
%patch $8BF9 $0F #Level 15 is the last one that gets marked as done
%patch $8DA1 $90 $90


#####################################
#OWN DIAGONAL MOVING SPRITE FOR KEEN#
#####################################

#Change Map Keen's diagonal walking animations
%patch $B4E6 $008EW #Keen moving up left - 4 frames
%patch $B503 $007AW #Keen moving up right - 4 frames
%patch $B520 $007EW #Keen moving down right - 4 frames
%patch $B53D $008AW #Keen moving down left - 4 frames


###############################
#OWN IN-AIR SHOOTING ANIMATION#
###############################

#Keen jumping left and shooting together (Ctrl pressed Then alt)
%patch $749F $003AW

#Keen jumping right and shooting together (Ctrl pressed Then alt)
%patch $74A7 $0047W

#Keen pogoing left and shooting (alt pressed first, then ctrl)
%patch $76D9 $0047W

#Keen pogoing right and shooting (alt pressed first, then ctrl)
%patch $76D1 $003AW


#######################
#NEGATIVE PALETTE MODE#
#######################

#Make an inverted palette for lights off:
%patch $19854  $1F $16 $15 $14 $13 $12 $19 $10  $07 $0E $05 $04 $0B $0A $09 $00  $01

#Make 'Lights off' use the new palette 
%patch $6C6C  $34 $00 


#######
#FILES#
#######

#Story text file
%patchfile $18BD0 "STORYTXT.CK3" #3'120 bytes

#Help text file
%patchfile $179D0 "HELPTEXT.CK3" #2'000 bytes

#Preview text file
%patchfile $184E0 "PREVIEWS.CK3" #1'776 bytes

#Ending text file
%patchfile $181A0 "ENDTEXT.CK3" #832 chars

#Tileinfo file
%patchfile 0x198C8 TILEINFO.CK3

#New B800 screen
%patchfile $12AC7 DOSSCN.CK3


###################
#STARTING SEQUENCE#
###################

#Don't display 'AN'
%patch $A9DC $EB $13

#Presentation
%patch $AA0B $0013W #Vertical position relative to APOGEE (pixels)

#Id Software
%patch $AA2F $0067W #Vertical position (pixels)

#Of an
%patch $AA1D $0057W #Vertical position (pixels)

#Production
%patch $AA41 $0092W #Vertical position (pixels)


#######
#TITLE#
#######

#Locations:
%patch $A08C $0000W #Title V


#################
#ENDING SEQUENCE#
#################

#No flashes
%patch $5B8A $E9 $0148W

#Text 1
%patch $1C36D "'Thank you for saving us, Commander " $0A $00
%patch $1C395 "Keen! Now that we are freed of the" $0A $00
%patch $1C3BB "mental terror as well, your human   " $0A $00
%patch $1C3E3 "friend owe us with explanation...'  " $0A $00

#Text 2
%patch $1C40B "''I am Michael McKenzie and I can     " $0A $00
%patch $1C433 "easily be influenced, that's why I was" $0A $00
%patch $1C45B "used as a distraction puppet person''" $0A $00

#Text 3
%patch $1C482 "''by Mortimer McMire's forcing for the" $0A $00
%patch $1C4AA "failure of his previous plans. But I'm" $0A $00
%patch $1C4D2 "honestly and very sorry.''" $0A $00

#Text 4
%patch $5B65 $0014W #Bottom side location
%patch $5B69 $0025W #Right side location
%patch $5B7B $2CE7W #First Line of text read from
%patch $1C507 "  ''Forgive me!''" $0A $00

#Don't show...
%patch $5A73 $EB $16 #Don't show Vorticon
%patch $5A8B $EB $15 #Don't show Keen

#Disable 'The End' text window
%patch $5D1D $EB $43

#Finale level
%patch $5CFB $005BW #Newly created 'LEVEL91'

#Ending sounds
%patch $5D88 $22 #Mortimer sound


#################################
#ABOUT ID/ORDER INFO/HIGH SCORES#
#################################

#Stop demo sequence
%patch $9A3E $90 $90


##########################################################
#KEEN GALAXY-STYLE LOADING WINDOW BEFORE ENTERING A LEVEL#
#(Side effect: Messie cannot be ridden)                  #
##########################################################

#Move up Teleporter-BwB-level entry call code
%patch $B74A $83 $3E $70ECW  $00 $74 $1B $FF $76 $F2 $FF $76 $F4 $56 $FF $36
             $70ECW  $E8 $0063W  $83 $C4 $08 $0B $C0 $74 $06 $C7 $06 $70ECW 
             $0000W  $5F $5E $8B $E5 $5D $C3

#Move code pointer list
%patch $B772 $B4EAW $B4F6W $B507W $B513W $B524W $B530W $B541W $B4D9W

#New list location
%patch $B4D7 $B772W

#Level name code pointer list
%patch $B782 $B802W  $B808W  $B80EW  $B814W  $B81AW  $B820W  $B826W $B82CW
             $B832W  $B838W  $B83EW  $B844W  $B84AW  $B850W  $B856W $B85CW
             $B862W  $B868W  $B86EW  $B874W  $B87AW  $B880W  $B886W $B88CW
             $B892W  $B898W  $B89EW  $B8A4W  $B8AAW  $B8B0W  $B8B6W $B8BCW  

#New expanded level entry code, includes level entrance texts
%patch $B7C2 $55 $8B $EC $83 $EC $04 $56 $57 $83 $7E $04 $21 $72 $03 $E9 $0176W
                 $A1 $70ECW  $8B $F8 $B8 $0004W  $50 $B8 $0018W  $50 $E8 $6E55W
                 $59 $59 $B8 $35E4W  $50 $E8 $7057W  $59 $8B $36 $86 $82 $8B
                 $DF $83 $FB $20 $76 $03 $E9 $00C1W  $D1 $E3 $2E $FF $A7 $B780W

#Level name code
%patch $B802 $B8 $3605W  $50 $EB $04 $B8 $3643W  $50 $EB $7C $B8 $3693W  $50 $EB $76
             $B8 $36C3W  $50 $EB $70 $B8 $33CEW  $50 $EB $6A $B8 $33F3W  $50 $EB $64
             $B8 $341AW  $50 $EB $5E $B8 $343EW  $50 $EB $58 $B8 $3465W  $50 $EB $52
             $B8 $348CW  $50 $EB $4C $B8 $34B3W  $50 $EB $46 $B8 $34D8W  $50 $EB $40
             $B8 $34F8W  $50 $EB $3A $B8 $351EW  $50 $EB $34 $B8 $3545W  $50 $EB $2E
             $B8 $356EW  $50 $EB $28 $B8 $35E4W  $50 $EB $22 $B8 $35E4W  $50 $EB $1C
             $B8 $35E4W  $50 $EB $16 $B8 $35E4W  $50 $EB $10 $B8 $35E4W  $50 $EB $0A
             $B8 $35E4W  $50 $EB $04 $B8 $35E4W  $50 $EB $7A $B8 $35E4W  $50 $EB $74
             $B8 $35E4W  $50 $EB $6E $B8 $35E4W  $50 $EB $68 $B8 $35E4W  $50 $EB $62
             $B8 $35E4W  $50 $EB $5C $B8 $35E4W  $50 $EB $56 $B8 $35E4W  $50 $EB $50
             $B8 $35E4W  $50 $EB $4A $B8 $35E4W  $50 $EB $44

#Press a key text
%patch $B90F $0001W #Number of lines text starts at

#Keen enters level after window is displayed
%patch $B943 $EB $04

#Level entry texts
%patch $1CE04 "  You're now entering" $0A $00
%patch $1CE25 " level 1: Snowy Fields" $0A $00 #Level 1
%patch $1CE63 "   level 2: Cold Hut" $0A $00 #Level 2
%patch $1CEB3 "  level 3: Maze Cave" $0A $00 #Level 3
%patch $1CEE3 "  level 4: Frosty Lair" $0A $00 #Level 4
%patch $1CBEE "  level 5: Icy District" $0A $00 #Level 5
%patch $1CC13 "level 6: Vorticon Shrine" $0A $00 #Level 6
%patch $1CC3A "   level 7: Rock Dome" $0A $00 #Level 7
%patch $1CC5E "   level 8: Hotel V" $0A $00 #Level 8
%patch $1CC85 " level 9: Engine House" $0A $00 #Level 9
%patch $1CCAC " level 10: Military Room" $0A $00 #Level 10
%patch $1CCD3 "level 11: Reactor Center" $0A $00 #Level 11
%patch $1CCF8 "  level 12: Cafeteria" $0A $00 #Level 12
%patch $1CD18 "  level 13: Cage Room" $0A $00 #Level 13
%patch $1CD3E "level 14: Defense Galley" $0A $00 #Level 14
%patch $1CD65 "level 15: Mystic Island" $0A $00 #Level 15
%patch $1CD8E "level 16: BWB Megarocket" $0A $00 #Level 16

#Read from: (Hard to change)
%patch $B915 $35A1W #Press a
%patch $B926 $35B1W #Key
%patch $B930 $35C1W #Button

#Press a key message (note it starts with $0A)
%patch $1CDC1 $0A "     p" $00
%patch $1CDD1 "ress a key:" $00
%patch $1CDE1 "ress a button:" $00


##################
#HIGH SCORE NAMES#
##################

#Default highscore names
%patch $1C5B1 "Szemigi  " $00
%patch $1C5C0 "Levellass" $00
%patch $1C5CF "DoomJedi " $00


##############################################
#SINGLE BULLET/POGO/RAYGUN/ANKH/BUBBLE SHIELD#
##############################################

#What Ankh gives
%patch $7BA1 $9D46W $01 $00 #Extra Keen

#Remove Ankh counter from status window
%patch $106E $90 #Ankh time v position

#Don't show Ankh tile
%patch $105D $90 $90 $90

#Solid shield
%patch $850D $006BW #Sprite used

#Flashing shield
%patch $854F $006BW #Sprite used

#Pogo GIVES 5 shots
%patch $7AD6  $83 $06 $9D48W $05 $90

#Related sounds
%patch $7ADD $0A     #Get pogo/raygun sound
%patch $7BA6 $1C     #Get ankh/single bullet
%patch $7BFA $0A     #Get single bullet sound


###########
#MAIN MENU#
###########

#Menu pointers
%patch $9EDC $9E68W # New Game + About ID...
             $9E56W # Continue Game
             $9E5EW # Story
             $9E78W # High Scores
             $9E9CW # Previews!
             $9EACW # Restart Demo

#Menu bottom item
%patch $9CF6 $05    #Moving down
%patch $9C72 $0005W #When wrapping from top
%patch $9EB9 $05    #When refreshing window

#Menu box size
%patch $9EF0 $0008W #Height

#Id bitmap
%patch $A0EC $0011 #H position, in 8x8 blocks

#New Game intro
%patch $1C870 "" $0A $00
%patch $1C898 "" $0A $00
%patch $1C8C0 "" $0A $00
%patch $1C8E8 "庠" $0A $00
%patch $1C910 "庠堠" $0A $00
%patch $1C938 "庠䠠" $0A $00
%patch $1C960 "Ѡ庠" $0A $00
%patch $1C988 "䠠" $0A $00
%patch $1C9B0 "" $0A $00
%patch $1C9D8 "" $0A $00
%patch $1CA00 "Ӡ٠Ϡž" $0A $00

#Simple Main Menu text patch (Frees $9F1C-$9F59)
%patch $9F13 $2FB5W  $50 $E8 $892AW  $59 $EB $3E

#Menu text
%patch $1C7D5 "   New Game" $0A
              "   Continue Game" $0A
              "   Story" $0A
              "   High Scores" $0A
              "   Previews!" $0A
              "   Restart Demo" $0A $0A
              "Use the " $00

#New Game has intro
%patch $9E68 $9A $000011BERL #Starting new game with About ID screen


###############
#STATUS WINDOW#
###############

#Text
%patch $1BAF4 "    SCORE     EXTRA KEEN AT " $0A $00
%patch $1BB12 " " $0A $00
%patch $1BB15 "    KEENS            WEAPON " $0A $00
%patch $1BB33 " " $0A $00
%patch $1BB36 " " $0A $00
%patch $1BB39 " " $0A $00
%patch $1BB3C "         KEY CARDS          " $0A $00
%patch $1BB5A "" $0A $00
%patch $1BB5D "" $0A $00
%patch $1BB60 "" $0A $00
%patch $1BB63 "     PLEASE PRESS A KEY     " $00

#Keycard graphics' position horizontally
%patch $1084 $0007W

#Keycard graphic tile
%patch $1099 $014AW #Yellow keycard tile
%patch $10BB $014BW #Red keycard tile
%patch $10E0 $014CW #Green keycard tile
%patch $1105 $014DW #Blue keycard tile

#Raygun graphic 
%patch $100E $023DW


#########
#VORTEEN#
#########

#Foob sprite type:
%patch $3E1B $05

#Starting speeds
%patch $3E68 $00E0W #If left of Keen (Move right)
%patch $3E61 $FEFFW #If right of Keen (Move left)

#Speed when walking about randomly
%patch $4AC4 $FEFFW #Hits right wall (Go left)
%patch $4AD0 $00E0W #Hits left wall (Go right)

#Sprite collision
%patch $4B8A $3D $05 #Foob killed by Keen (Nothing happens)
%patch $4B8F $3D $05 #Foob killed by Keengun (Nothing happens)
%patch $4B94 $3D $06 #Foob killed by VortiNinja

#Foob don't run from Keen
%patch $4A9C $EB

#Sprite animations
%patch $4A1E $005DW #Walking right
%patch $4A26 $0060W #Walking left
%patch $4A30 $02    #2 frames used 

#Dying sprite frame
%patch $4BAD $0063W #When shot
%patch $4BA8 $03    #Frames used

#Foob scared sound disabled
%patch $4AAA $EB $06

#Foob dies sound
%patch $4B99 $2D #Foot slam sound


#########################
#KEEN'S UNSTUNNING FRAME#
#########################

#Extra frame when unstunning -Keen 3
%patch $5588 $0B5FW
%patch $0B5F $55 $8B $EC $C7 $06 $9938W  $0092W  $A1 $993AW  $03 $06 $5D40W
             $A3 $993AW  $83 $3E $993AW  $14 $7E $06 $C7 $06 $9942W  $6F07W
             $5D $C3


################
#GRAND DERELICT#
################

#Vortimom strength - 25
%patch $3D1C $19 $00

#Shooting Vortimom wins the game
%patch $473D $90

#No pause before Vortimom shoots
%patch $44DC $EB $07

#Vortimom's bullet has 1 frame only
%patch $467C $00

#Replacement of Vorticon Mom and Vorticon Grunt
%patch $4252 $44B9W #'Look for Keen' after landing\stopping sliding
%patch $4469 $4275W #Shoot randomly

#Meep just walks off platform edges
%patch $47A1 $83 $3E $30 $99 $00 $7E $08 $C7 $06 $30 $99 $0041W $EB $06 $C7
             $06 $30 $99 $FFBFW  $90 $90

#'Looking for Keen' animation (1 frame only)
%patch $4286 $00

#Vorticon Mom walking speed
%patch $3D3C $FF88W #If left of Keen (Move right)
%patch $3D35 $0078W #If right of Keen (Move left)

#Speed when walking about randomly:
%patch $44A6 $00DCW #Hits right wall (Go left)
%patch $44B2 $00DCW #Hits left wall (Go right)

#Shot speed:
%patch $4502 $FE70W #Left speed
%patch $4507 $0190W #Right speed

#Vortimom uses 4 frames in both directions
%patch $4426 $0055W #Walking right
%patch $441E $0059W #Walking left
%patch $4430 $03    #Frames used - 1

#Vorticon mom shoot sprite
%patch $44C8 $0051W #Shooting right
%patch $44D0 $0052W #Shooting left

#Vortimom death sprite
%patch $4737 $0054W #When shot
%patch $4732 $01    #Frames used

#Bullet sprite
%patch $45F8 $0039W #Bullet right that is sprite 57
%patch $4581 $0039W #Bullet left that is sprite 57

#Vorticon never looks for Keen
%patch $4275 $55 $8B $EC $C7 $06 $30 $99 $0000W  $A1 $61 $53 $B1 $05 $D3 $E8
             $25 $0003W  $05 $0041W  $A3 $38 $99 $A1 $3A $99 $03 $06 $40 $5D
             $A3 $3A $99 $83 $3E $3A $99 $00 $7C $29 $C7 $06 $30 $99 $005AW
             $A1 $16 $99 $8B $16 $14 $99 $3B $06 $0C $71 $7C $10 $7F $06 $3B
             $16 $0A $71 $76 $08 $A1 $30 $99 $F7 $D8 $A3 $30 $99 $C7 $06 $42
             $99 $414AW  $E8 $1FE9W  $E8 $2029W  $5D $C3

#Vortimom BULLET height (Default $00000D, if zero then no shot appears)
%patch $4560    $12
%patch $4562 $0000W


################
#INITIALIZATION#
################

#Don't show
%patch $1242 $EB $06 #Loading


##########
#PLATFORM#
##########

#Platform changes direction without pausing\turning
%patch $4C47 $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0001W  $05 $006BW
                 $A3 $38 $99 $E8 $1699W  $8B $F0 $F7 $C6 $02 $00 $74 $06 $C7
             $06 $32 $99 $FFB5W  $F7 $C6 $08 $00 $74 $06 $C7 $06 $32 $99 $004BW 
                 $F7 $C6 $04 $00 $74 $06 $C7 $06 $30 $99 $FFB5W  $F7 $C6 $01
             $00 $74 $06 $C7 $06 $30 $99 $004BW  $5E $5D $C3

#In-level animations
%patch $4C56 $0082W #Both platforms moving
%patch $4C53 $07    #And next frame


#############
#FREE GOPLAT#
#############

#Ball starting speeds
%patch $3ECA $FFF0W #If spawned above/left of Keen (Move right)
%patch $3EC3 $FFF0W #If spawned below right of Keen (Move left)
%patch $3EEA $FFF0W #If spawned above Keen (Move down)
%patch $3EE3 $FFF0W #If spawned below Keen (Move up)

#Ball in level
%patch $4C1E $FFF0W #Ball bounce left speed
%patch $4C2A $0010W #Ball bounce right speed
%patch $4C36 $FFF0W #Ball bounce upwards speed
%patch $4C42 $0010W #Ball bounce downwards speed


#####################################
#MANGLING MACHINE/HEART/PURPLE SPARK#
#####################################

#MM text sequence
%patch $85D2 $08 $75 #Level 8

#MM level
%patch $8DF2 $000EW $75 #Win game in level 14

#Enter MM level sound
%patch $570F $1A

#Points you get for shooting a spark (10'000)
%patch $4E44 $2710W

#Points you get for shooting a heart (2000)
%patch $4EE9 $07D0W

#Spark sprite type:
%patch $4071 $09

#Heart sprite type:
%patch $40AE $05

#Heart has only 1 frame
%patch $4EB4 $00

#Sprite used for the heart
%patch $4EB7 $0093W

#Stop 1st textbox appearing
%patch $5721 $EB $35

#Stop 2nd textbox appearing
%patch $575B $EB $35

#Stop 3rd textbox appearing
%patch $5792 $EB $35

#Stop 5th textbox appearing
%patch $5848 $EB $7D

#Stop 6th textbox appearing
%patch $58C7 $EB $47

#Stop 7th textbox appearing
%patch $5910 $EB $6B

#Stop 8th textbox appearing
%patch $597D $EB $33

#Stop 9th textbox appearing
%patch $59B2 $EB $52

#4th box's text
%patch $1C0B3 "'There's a fifth, Vorticon keycard    " $0A $00
%patch $1C0DB "that replaces all the four types due  " $0A $00
%patch $1C103 "to sparing reasons. But by the way,  " $0A $00
%patch $1C12A "the Vorticon Lieutenants also keep " $0A $00
%patch $1C14F "weapons on the Fathership as well.'  " $00


################
#VORTICON DROID#
################

#Jack sprite type:
%patch $3EFF $05

#Jack collision uses Vortikid one
%patch $3F27 $43D9W

#Jack chases Keen
%patch $4BBD $55 $56 $57 $A1 $61 $53 $C1 $E8 $05 $83 $E0 $03 $83 $C0 $6E $A3
             $38 $99 $66 $A1 $14 $99 $66 $3B $06 $0A $71 $7F $08 $C7 $06 $30
             $99 $003CW  $EB $06 $C7 $06 $30 $99 $FFC4W  $66 $A1 $18 $99 $66
             $3B $06 $0E $71 $7F $08 $C7 $06 $32 $99 $003CW  $EB $06 $C7 $06
             $32 $99 $FFC4W  $E8 $16F3W  $5F $5E $5D $C3


#######################
#VORTICON GRUNT (GREY)#
#######################

#Meep's spawn height
%patch $3D6C $0000W #Zero pixels down

#Meep sprite type:
%patch $3D51 $02

#Some new sprites for the Meep
%patch $4755 $003BW #Walking right
%patch $475D $0076W #Walking left
%patch $4767 $03    #And next frame

#Shooting
%patch $47EA $0048W #Left
%patch $47E2 $0048W #Right

#Disable Meep sounds
%patch $480D $EB $06 #Meep shooting sound disabled
%patch $48AE $EB $06 #Meep shot sound disabled

#Speeds
%patch $3DA4 $0061W     #Initial right speed (If left of Keen)
%patch $3D9D $FFBFW     #Initial left speed (If right of Keen)

#In level
%patch $47CE $0061W     #When hits left walls (Move right)
%patch $47C2 $FFBFW     #When hits right walls (Move left)

#Dead sprite
%patch $48C3 $004FW #Shot
%patch $48BE $02    #Frames used

#Meep doesn't shoot either direction
%patch $481F $EB $38


###############
#ENEMY SHOOTER#
###############

#Shot sprite type:
%patch $4D95 $03 #Horizontal
%patch $4DFC $0F #Vertical


#####################
#VORTICON LIEUTENANT#
#####################

#Jump when Keen is spotted
%patch $4997 $4311W

#Speed when walking/jumping
%patch $3CDA $005AW #If left of Keen (Move right)
%patch $3CD3 $FFA6W #If right of Keen (Move left)

#Vortininja strength - 8
%patch $3DE6 $07 $00

#Speed when hitting left wall (Go right)
%patch $438C $005AW

#Speed when hitting left wall (Go right)
%patch $4380 $FFA6W

#Jump height
%patch $4350 $012CW

#When falling\sliding
%patch $43D4 $005AW #Hits left wall (Go right)
%patch $43C8 $FFA6W #Hits right wall (Go left)

#VortiNinja dead sprite
%patch $49FD $004BW #Shot
%patch $49F8 $02    #Frames used

#VortiNinja standing pose
%patch $492A $004DW #Standing right
%patch $491C $004DW #Standing left


#############
#DONE MARKER#
#############

#Move the Done tile markers, which are now animated (YES!)
%patch $8B31 $003DW #Small marker
%patch $8BAA $002DW #Big marker top left
%patch $8BC3 $0036W #Big marker top right
%patch $8BDA $0029W #Big marker bottom left
%patch $8BF4 $003AW #Big marker bottom right


###################
#ICE TILE PROPERTY#
###################

#Keen can change his direction while on ice
%patch $6FB9 $03 $90 $90
%patch $7043 $03 $EB



%end        